<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:exsl="http://exslt.org/common"
                extension-element-prefixes="exsl"
                version="1.0">

<!-- Import original stylesheet -->
<xsl:import href="http://docbook.sourceforge.net/release/xsl/current/html/docbook.xsl"/>

<xsl:template match="/">
  <!-- Grab result of original stylesheet -->
  <xsl:variable name="content">
    <xsl:apply-imports/>
  </xsl:variable>

  <!-- Pass grabbed content to postprocessing templates -->
  <xsl:apply-templates select="exsl:node-set($content)"
                       mode="decoratelinks"/>
</xsl:template>

<!-- Default postprocessing is just copying of nodes -->
<xsl:template match="@*|*|text()" mode="decoratelinks">
  <xsl:copy>
    <xsl:apply-templates select="@*|*|text()" 
                         mode="decoratelinks"/>
  </xsl:copy>
</xsl:template>

<!-- Absolute links starting with "http" are external and we
     must add icon to them -->
<xsl:template match="a[starts-with(@href,'http')]" 
              mode="decoratelinks">
  <xsl:copy>
    <!-- Copy original <a> attributes -->
    <xsl:apply-templates select="@*" mode="decoratelinks"/>
    <!-- Insert image -->
    <img src="external.gif" width="16" height="16" border="0"/>
    <xsl:text>&#160;</xsl:text>
    <!-- Copy content (subelements and text nodes) of <a> -->
    <xsl:apply-templates select="*|text()" 
                         mode="decoratelinks"/>
  </xsl:copy>
</xsl:template>
  
</xsl:stylesheet>